<?php

namespace Drupal\registration_extra;

use Drupal\Core\Session\AccountProxyInterface;
use Drupal\Core\Url;
use Drupal\Core\Entity\EntityTypeInterface;
use Symfony\Component\HttpFoundation\Session\SessionInterface;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Drupal\node\Entity\Node;

class RegistrationExtraService 
{
  public $currentUser;
  public $session;
  
	public function __construct(AccountProxyInterface $current_user, SessionInterface $session) {
    $this->currentUser = $current_user;
    $this->session = $session;
  }

/*
protected function getSingleMessage($registration_type) {
    $query = \Drupal::entityQuery('registration');
    $query->accessCheck(TRUE);
    $query->condition('type', $registration_type);
    $query->sort('registration_id', 'DESC');
    $query->range(0, 1);
    if ($mids = $query->execute()) {
      $mid = reset($mids);
      if ($message = Registration::load($mid)) {
        return $message;
      }
    }
    return FALSE;
  }*/

  public function getLabels(Registration $registration) {
    $labels = [];
    foreach ($message->getFieldDefinitions() as $key => $field) {
      if ($label = $field->getLabel()) {
        // Remove characters not allowed in keys of associative arrays.
        $labels[$key] = filter_var($label, FILTER_UNSAFE_RAW,
          FILTER_FLAG_STRIP_HIGH | FILTER_FLAG_STRIP_LOW | FILTER_FLAG_NO_ENCODE_QUOTES
        );
      }
    }
    return $labels;
  }
}